﻿using UnityEngine;

class FirestormProjectileBehaviour : MonoBehaviour
{

    Vector3 pos;
    Vector3 dir;

    Vector3 targetDir;

    void Update()
    {
        var collider = Physics2D.OverlapCircleAll(transform.position, 25f);

        pos = transform.position;
        dir = transform.up;

        float bulletDist;

        if (collider == null)
        {
            targetDir = transform.up;
            bulletDist = 0f;
        }
        else
        {
            targetDir = transform.up;
            bulletDist = 0f;

            for (int i = 0; i < collider.Length; i++)
            {
                if (collider[i].GetComponent<LimbBehaviour>() != null && collider[i].GetComponent<LimbBehaviour>().Person.IsAlive())
                {
                    targetDir = (collider[i].transform.position - transform.position).normalized;
                    bulletDist = Vector3.Distance(pos, collider[i].transform.position);
                }
            }
        }

        float value = Mathf.Approximately(bulletDist, 0) ? 0 : 25f / bulletDist;
        float inverseDistance = Mathf.Clamp(value, 0f, 25f);

        transform.up = Vector3.Lerp(dir, targetDir, (inverseDistance) * Time.deltaTime * 10);
    }

    void OnCollisionEnter2D(Collision2D other)
    {
        GetComponent<PhysicalBehaviour>().BurnProgress = 1f;
    }
}
