﻿using System.Collections;
using UnityEngine;

namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static string ModTag = " [TZMWW]";

        public static void Main()
        {
            //1.0

            //megacannon
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Detached Megacannon" + ModTag,
                NameToOrderByOverride = "Detached Cannon 5",
                DescriptionOverride = "Beam cannon exclusively for blowing holes into the surface of mars. It's missing all the pieces except for the barrel.",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/Detached Megacannon Thumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Destroy(Instance.GetComponent<BoxCollider2D>());

                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 100f;
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Detached Megacannon.png");
                    var a = Instance.AddComponent<BoxCollider2D>();
                    var b = Instance.AddComponent<BoxCollider2D>();
                    var c = Instance.AddComponent<PolygonCollider2D>();

                    a.offset = new Vector2(0.3f, 0f);
                    a.size = new Vector2(2.2f, 1.85f);

                    b.offset = new Vector2(-1.7f, 0f);
                    b.size = new Vector2(1.75f, 1.2f);

                    c.points = new Vector2[]
                    {
                        new Vector2(1.4f, -0.95f),
                        new Vector2(1.4f, 0.95f),
                        new Vector2(2.85f, 0f)
                    };

                    Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { };

                    if (Instance.GetComponent<AfterFirstSpawn>() == null)
                    {
                        Instance.AddComponent<AfterFirstSpawn>();
                        Instance.AddComponent<MegacannonBehaviour>();
                    }
                }
            });

            //airstrike
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "Airstrike Radio" + ModTag,
                DescriptionOverride = "Magically informs the dutch military that you need an area bombed and they just comply without questioning it.",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/Airstrike Radio Thumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Destroy(Instance.GetComponent<BoxCollider2D>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Airstrike Radio.png");
                    var a = Instance.AddComponent<BoxCollider2D>();
                    a.offset = new Vector2(0.015f, -0.1f);
                    a.size = new Vector2(0.3f, 0.45f);
                    if (Instance.GetComponent<AfterFirstSpawn>() == null)
                    {
                        Instance.AddComponent<AfterFirstSpawn>();
                        Instance.AddComponent<AirstrikeBehaviour>();
                    }
                }
            });

            //Harpoon Cannon
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Harpoon Cannon" + ModTag,
                    DescriptionOverride = "A retractable harpoon cannon. \nIts base is frozen when created.",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/Harpoon Cannon Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Harpoon Mount.png");

                        Destroy(Instance.GetComponent<BoxCollider2D>());
                        Instance.GetComponent<PhysicalBehaviour>().HoldingPositions = new Vector3[] { };

                        #region base colliders
                        var a = Instance.AddComponent<BoxCollider2D>();
                        var b = Instance.AddComponent<BoxCollider2D>();
                        var c = Instance.AddComponent<PolygonCollider2D>();

                        a.offset = new Vector2(0f, -0.35f);
                        a.size = new Vector2(0.66f, 0.5f);

                        b.offset = new Vector2(0.15f, 0.25f);
                        b.size = new Vector2(0.34f, 0.75f);

                        c.points = new Vector2[]
                        {
                        new Vector2(-0.25f, -0.3f),
                        new Vector2(-0.55f, -0.65f),
                        new Vector2(0.55f, -0.65f),
                        new Vector2(0.25f, -0.3f)
                        };
                        #endregion

                        GameObject cannon = ModAPI.CreatePhysicalObject("yeah", ModAPI.LoadSprite("sprites/Harpoon Cannon.png"));
                        var sprite = cannon.GetComponent<SpriteRenderer>();
                        sprite.sortingOrder = 10;
                        cannon.transform.parent = Instance.transform;
                        cannon.transform.localScale = Vector3.one;
                        cannon.transform.localPosition = new Vector3(0.165f, 0.45f);

                        #region cannon colliders
                        var d = cannon.AddComponent<BoxCollider2D>();
                        var e = cannon.AddComponent<BoxCollider2D>();

                        d.size = new Vector2(1f, 0.35f);

                        e.offset = new Vector2(-0.05f, 0f);
                        e.size = new Vector2(0.3f, 0.6f);
                        #endregion

                        HingeJoint2D joint = cannon.AddComponent<HingeJoint2D>();
                        joint.connectedBody = Instance.GetComponent<Rigidbody2D>();
                        joint.useLimits = true;
                        var angle = new JointAngleLimits2D();
                        angle.max = 45f;
                        angle.min = -45f;
                        joint.limits = angle;

                        GameObject harpoon = ModAPI.CreatePhysicalObject("harpoon", ModAPI.LoadSprite("sprites/Harpoon.png"));
                        harpoon.GetComponent<SpriteRenderer>().sortingOrder = 9;
                        harpoon.transform.parent = cannon.transform;
                        harpoon.transform.localScale = Vector3.one;
                        harpoon.transform.localPosition = new Vector3(0.5f, 0.05f);

                        var f = harpoon.AddComponent<BoxCollider2D>();

                        var phys = harpoon.GetComponent<PhysicalBehaviour>();

                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 10f;
                        cannon.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5f;
                        phys.TrueInitialMass = 1f;

                        var prop = phys.Properties;
                        prop.Sharp = true;
                        prop.SharpAxes = new SharpAxis[] { new SharpAxis(Vector2.right, -0.5f, 0.455f, true, true) };

                        FixedJoint2D joint2 = harpoon.AddComponent<FixedJoint2D>();
                        joint2.connectedBody = cannon.GetComponent<Rigidbody2D>();

                        foreach (Collider2D collider2D in Instance.GetComponentsInChildren<Collider2D>())
                            foreach (Collider2D collider2D2 in Instance.GetComponentsInChildren<Collider2D>())
                                Physics2D.IgnoreCollision(collider2D, collider2D2);

                        if (Instance.GetComponent<AfterFirstSpawn>() == null)
                        {
                            Instance.AddComponent<AfterFirstSpawn>();
                            Instance.AddComponent<FreezeBehaviour>();
                            cannon.AddComponent<HarpoonCannonBehaviour>();
                            harpoon.AddComponent<PointToVelocityBehaviour>().intensity = 0.01f;
                        }
                    }
                });


            //firework crossbow
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                NameOverride = "Firestorm" + ModTag,
                DescriptionOverride = "A homing, fully automatic firework gun. This is overkill. \n\n<b>Maybe don't use this if you're epileptic. Seriously.</b>",
                CategoryOverride = ModAPI.FindCategory("Firearms"),
                ThumbnailOverride = ModAPI.LoadSprite("sprites/Firestorm Thumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Firestorm.png");

                    var launcher = Instance.GetComponent<ProjectileLauncherBehaviour>();
                    launcher.projectileAsset = ModAPI.FindSpawnable("Fireworks");
                    launcher.IsAutomatic = true;
                    launcher.AutomaticInterval = 0.05f;
                    launcher.projectileLaunchStrength = 0f;
                    launcher.RemoveLaunchedObjectsWithMe = true;
                    launcher.barrelPosition = new Vector2(0.75f, 0.1f);

                    launcher.OnLaunch += (sender, proj) =>
                    {
                        proj.transform.Rotate(0f, 0f, Random.Range(-80f, -100f));
                        proj.transform.localScale = Instance.transform.localScale;
                        proj.AddComponent<FirestormProjectileBehaviour>();
                        var firework = proj.GetComponent<FireworksBehaviour>();
                        firework.Thrust *= 4f;
                        firework.Life *= 2f;
                        firework.Activated = true;
                        firework.Audio.Play();
                    };
                }
            });
        }

        public static void OnLoad()
        {
            ModResources.beamSFX = ModAPI.LoadSound("sfx/beam.wav");
            ModResources.beam2SFX = ModAPI.LoadSound("sfx/beam2.wav");
            ModResources.beamchargeSprite = ModAPI.LoadSprite("sprites/MCCharge.png");

            ModResources.confirmSFX = ModAPI.LoadSound("sfx/confirm.wav");
            ModResources.harpoonLaunchSFX = ModAPI.LoadSound("sfx/harpoonLaunch.wav");
            ModResources.harpoonReloadSFX = ModAPI.LoadSound("sfx/harpoonReload.wav");
        }
    }
}